diff --git a/arch/x86/entry/syscalls/syscall_64.tbl b/arch/x86/entry/syscalls/syscall_64.tbl
index 44d510bc9b78..5345c06f6987 100644
--- a/arch/x86/entry/syscalls/syscall_64.tbl
+++ b/arch/x86/entry/syscalls/syscall_64.tbl
@@ -359,6 +359,8 @@
 435	common	clone3			__x64_sys_clone3/ptregs
 437	common	openat2			__x64_sys_openat2
 438	common	pidfd_getfd		__x64_sys_pidfd_getfd
+439	common	exchange_pages	__x64_sys_exchange_pages
+440	common	mm_manage		__x64_sys_mm_manage
 
 #
 # x32-specific system call numbers start at 512 to avoid cache impact
diff --git a/fs/aio.c b/fs/aio.c
index 5f3d3d814928..0027b7d3ac19 100644
--- a/fs/aio.c
+++ b/fs/aio.c
@@ -386,7 +386,7 @@ static int aio_migratepage(struct address_space *mapping, struct page *new,
 	 * happen under the ctx->completion_lock. That does not work with the
 	 * migration workflow of MIGRATE_SYNC_NO_COPY.
 	 */
-	if (mode == MIGRATE_SYNC_NO_COPY)
+	if (mode & MIGRATE_SYNC_NO_COPY)
 		return -EINVAL;
 
 	rc = 0;
@@ -434,7 +434,7 @@ static int aio_migratepage(struct address_space *mapping, struct page *new,
 	 * events from being lost.
 	 */
 	spin_lock_irqsave(&ctx->completion_lock, flags);
-	migrate_page_copy(new, old);
+	migrate_page_copy(new, old, MIGRATE_SINGLETHREAD);
 	BUG_ON(ctx->ring_pages[idx] != old);
 	ctx->ring_pages[idx] = new;
 	spin_unlock_irqrestore(&ctx->completion_lock, flags);
diff --git a/fs/f2fs/data.c b/fs/f2fs/data.c
index b27b72107911..697a5a3fd818 100644
--- a/fs/f2fs/data.c
+++ b/fs/f2fs/data.c
@@ -3593,7 +3593,7 @@ int f2fs_migrate_page(struct address_space *mapping,
 
 	/* migrating an atomic written page is safe with the inmem_lock hold */
 	if (atomic_written) {
-		if (mode != MIGRATE_SYNC)
+		if ((mode & MIGRATE_MODE_MASK) != MIGRATE_SYNC)
 			return -EBUSY;
 		if (!mutex_trylock(&fi->inmem_lock))
 			return -EAGAIN;
@@ -3626,8 +3626,8 @@ int f2fs_migrate_page(struct address_space *mapping,
 		f2fs_clear_page_private(page);
 	}
 
-	if (mode != MIGRATE_SYNC_NO_COPY)
-		migrate_page_copy(newpage, page);
+	if (!(mode & MIGRATE_SYNC_NO_COPY))
+		migrate_page_copy(newpage, page, MIGRATE_SINGLETHREAD);
 	else
 		migrate_page_states(newpage, page);
 
diff --git a/fs/hugetlbfs/inode.c b/fs/hugetlbfs/inode.c
index aff8642f0c2e..b5b37604d3f0 100644
--- a/fs/hugetlbfs/inode.c
+++ b/fs/hugetlbfs/inode.c
@@ -911,8 +911,8 @@ static int hugetlbfs_migrate_page(struct address_space *mapping,
 		set_page_private(page, 0);
 	}
 
-	if (mode != MIGRATE_SYNC_NO_COPY)
-		migrate_page_copy(newpage, page);
+	if (!(mode & MIGRATE_SYNC_NO_COPY))
+		migrate_page_copy(newpage, page, MIGRATE_SINGLETHREAD);
 	else
 		migrate_page_states(newpage, page);
 
diff --git a/fs/iomap/buffered-io.c b/fs/iomap/buffered-io.c
index 7c84c4c027c4..e1066a9cc855 100644
--- a/fs/iomap/buffered-io.c
+++ b/fs/iomap/buffered-io.c
@@ -554,8 +554,8 @@ iomap_migrate_page(struct address_space *mapping, struct page *newpage,
 		SetPagePrivate(newpage);
 	}
 
-	if (mode != MIGRATE_SYNC_NO_COPY)
-		migrate_page_copy(newpage, page);
+	if (!(mode & MIGRATE_SYNC_NO_COPY))
+		migrate_page_copy(newpage, page, mode);
 	else
 		migrate_page_states(newpage, page);
 	return MIGRATEPAGE_SUCCESS;
diff --git a/fs/proc/base.c b/fs/proc/base.c
index c7c64272b0fa..0a652e156826 100644
--- a/fs/proc/base.c
+++ b/fs/proc/base.c
@@ -211,6 +211,170 @@ static int proc_root_link(struct dentry *dentry, struct path *path)
 	return result;
 }
 
+#ifdef CONFIG_PAGE_MIGRATION_PROFILE
+static int proc_pid_move_pages_breakdown(struct seq_file *m, struct pid_namespace *ns,
+			struct pid *pid, struct task_struct *task)
+{
+	struct task_struct *t = task;
+	struct move_pages_breakdown move_pages_breakdown = t->move_pages_breakdown;
+
+	seq_printf(m,
+		"syscall_timestamp\t"
+		"check_rights_cycles\t"
+		"migrate_prep_cycles\t"
+		"form_page_node_info_cycles\t"
+		"form_physical_page_list_cycles\t"
+
+		"enter_unmap_and_move_cycles\t"
+		"split_thp_page_cycles\t"
+		"get_new_page_cycles\t"
+		"lock_page_cycles\t"
+		"unmap_page_cycles\t"
+		"change_page_mapping_cycles\t"
+		"copy_page_cycles\t"
+		"remove_migration_ptes_cycles\t"
+		"putback_old_page_cycles\t"
+		"putback_new_page_cycles\t"
+		"migrate_pages_cleanup_cycles\t"
+
+		"store_page_status_cycles\t"
+		"return_to_syscall_cycles\t"
+		"last_timestamp\t"
+		"\n"
+		);
+
+	seq_printf(m,
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+
+		"%llu\t"
+		"%llu\t"
+		"%llu\t"
+		"\n"
+		,
+		move_pages_breakdown.syscall_timestamp,
+		move_pages_breakdown.check_rights_cycles,
+		move_pages_breakdown.migrate_prep_cycles,
+		move_pages_breakdown.form_page_node_info_cycles,
+		move_pages_breakdown.form_physical_page_list_cycles,
+
+		move_pages_breakdown.enter_unmap_and_move_cycles,
+		move_pages_breakdown.split_thp_page_cycles,
+		move_pages_breakdown.get_new_page_cycles,
+		move_pages_breakdown.lock_page_cycles,
+		move_pages_breakdown.unmap_page_cycles,
+		move_pages_breakdown.change_page_mapping_cycles,
+		move_pages_breakdown.copy_page_cycles,
+		move_pages_breakdown.remove_migration_ptes_cycles,
+		move_pages_breakdown.putback_old_page_cycles,
+		move_pages_breakdown.putback_new_page_cycles,
+		move_pages_breakdown.migrate_pages_cleanup_cycles,
+
+		move_pages_breakdown.store_page_status_cycles,
+		move_pages_breakdown.return_to_syscall_cycles,
+		move_pages_breakdown.last_timestamp
+		);
+
+	t->move_pages_breakdown = (struct move_pages_breakdown){0};
+
+	return 0;
+}
+#endif
+
+static int proc_pid_page_migration_stats(struct seq_file *m, struct pid_namespace *ns,
+			struct pid *pid, struct task_struct *task)
+{
+	struct task_struct *t = task;
+	struct page_migration_stats stats;
+
+	stats = t->page_migration_stats;
+
+#define SHOW_PAGE_MIGRATION_COUNTERS(var) \
+		var.nr_migrations, \
+		var.nr_base_pages, \
+		var.nr_huge_pages
+
+#define SHOW_PAGE_MIGRATION_STATS(var) \
+		jiffies_to_msecs(var.base_page_under_migration_jiffies), \
+		jiffies_to_msecs(var.huge_page_under_migration_jiffies), \
+		var.nr_exchanges, \
+		var.nr_exchange_base_pages, \
+		var.nr_exchange_huge_pages, \
+		SHOW_PAGE_MIGRATION_COUNTERS(var.f2s), \
+		SHOW_PAGE_MIGRATION_COUNTERS(var.s2f)
+
+
+	seq_printf(m,
+		"WaitBasePageMigration_ms %u\n"
+		"WaitHugePageMigration_ms %u\n"
+		"ExchangePages_nr_exchanges %lu\n"
+		"ExchangePagesBase_nr_base_pages %lu\n"
+		"ExchangePagesHuge_nr_base_pages %lu\n"
+		"Fast2Slow_nr_migrations %lu\n"
+		"Fast2SlowBasePageMigrations_nr_base_pages %lu\n"
+		"Fast2SlowHugePageMigrations_nr_base_pages %lu\n"
+		"Slow2Fast_nr_migrations %lu\n"
+		"Slow2FastBasePageMigrations_nr_base_pages %lu\n"
+		"Slow2FastHugePageMigrations_nr_base_pages %lu\n",
+
+		SHOW_PAGE_MIGRATION_STATS(stats)
+
+		);
+
+	return 0;
+}
+
+static int proc_pid_child_stats(struct seq_file *m, struct pid_namespace *ns,
+			struct pid *pid, struct task_struct *task)
+{
+	struct task_struct *t = task;
+	unsigned long flags;
+
+	if (lock_task_sighand(t, &flags)) {
+		struct signal_struct *sig = t->signal;
+		struct page_migration_stats child_stats;
+
+		child_stats = sig->page_migration_stats;
+		unlock_task_sighand(t, &flags);
+
+		seq_printf(m,
+			"WaitBasePageMigration_ms %u\n"
+			"WaitHugePageMigration_ms %u\n"
+			"ExchangePages_nr_exchanges %lu\n"
+			"ExchangePagesBase_nr_base_pages %lu\n"
+			"ExchangePagesHuge_nr_base_pages %lu\n"
+			"Fast2Slow_nr_migrations %lu\n"
+			"Fast2SlowBasePageMigrations_nr_base_pages %lu\n"
+			"Fast2SlowHugePageMigrations_nr_base_pages %lu\n"
+			"Slow2Fast_nr_migrations %lu\n"
+			"Slow2FastBasePageMigrations_nr_base_pages %lu\n"
+			"Slow2FastHugePageMigrations_nr_base_pages %lu\n",
+
+			SHOW_PAGE_MIGRATION_STATS(child_stats)
+
+			);
+
+#undef SHOW_PAGE_MIGRATION_STATS
+	}
+
+	return 0;
+}
+
 /*
  * If the user used setproctitle(), we just get the string from
  * user space at arg_start, and limit it to a maximum of one page.
@@ -2564,7 +2728,7 @@ static struct dentry *proc_pident_instantiate(struct dentry *dentry,
 	return d_splice_alias(inode, dentry);
 }
 
-static struct dentry *proc_pident_lookup(struct inode *dir, 
+static struct dentry *proc_pident_lookup(struct inode *dir,
 					 struct dentry *dentry,
 					 const struct pid_entry *p,
 					 const struct pid_entry *end)
@@ -2751,7 +2915,7 @@ static const struct pid_entry attr_dir_stuff[] = {
 
 static int proc_attr_dir_readdir(struct file *file, struct dir_context *ctx)
 {
-	return proc_pident_readdir(file, ctx, 
+	return proc_pident_readdir(file, ctx,
 				   attr_dir_stuff, ARRAY_SIZE(attr_dir_stuff));
 }
 
@@ -3114,6 +3278,11 @@ static const struct pid_entry tgid_base_stuff[] = {
 #ifdef CONFIG_HAVE_ARCH_TRACEHOOK
 	ONE("syscall",    S_IRUSR, proc_pid_syscall),
 #endif
+#ifdef CONFIG_PAGE_MIGRATION_PROFILE
+	ONE("move_pages_breakdown",       S_IRUGO, proc_pid_move_pages_breakdown),
+#endif
+	ONE("child_stats", S_IRUGO, proc_pid_child_stats),
+	ONE("page_migration_stats", S_IRUGO, proc_pid_page_migration_stats),
 	REG("cmdline",    S_IRUGO, proc_pid_cmdline_ops),
 	ONE("stat",       S_IRUGO, proc_tgid_stat),
 	ONE("statm",      S_IRUGO, proc_pid_statm),
@@ -3515,6 +3684,11 @@ static const struct pid_entry tid_base_stuff[] = {
 #ifdef CONFIG_HAVE_ARCH_TRACEHOOK
 	ONE("syscall",   S_IRUSR, proc_pid_syscall),
 #endif
+#ifdef CONFIG_PAGE_MIGRATION_PROFILE
+	ONE("move_pages_breakdown",       S_IRUGO, proc_pid_move_pages_breakdown),
+#endif
+	ONE("child_stats", S_IRUGO, proc_pid_child_stats),
+	ONE("page_migration_stats", S_IRUGO, proc_pid_page_migration_stats),
 	REG("cmdline",   S_IRUGO, proc_pid_cmdline_ops),
 	ONE("stat",      S_IRUGO, proc_tid_stat),
 	ONE("statm",     S_IRUGO, proc_pid_statm),
diff --git a/fs/ubifs/file.c b/fs/ubifs/file.c
index 743928efffc1..8a0f55673045 100644
--- a/fs/ubifs/file.c
+++ b/fs/ubifs/file.c
@@ -1478,8 +1478,8 @@ static int ubifs_migrate_page(struct address_space *mapping,
 		SetPagePrivate(newpage);
 	}
 
-	if (mode != MIGRATE_SYNC_NO_COPY)
-		migrate_page_copy(newpage, page);
+	if (!(mode & MIGRATE_SYNC_NO_COPY))
+		migrate_page_copy(newpage, page, MIGRATE_SINGLETHREAD);
 	else
 		migrate_page_states(newpage, page);
 	return MIGRATEPAGE_SUCCESS;
diff --git a/include/linux/cgroup-defs.h b/include/linux/cgroup-defs.h
index 63097cb243cb..9ee3bc476d26 100644
--- a/include/linux/cgroup-defs.h
+++ b/include/linux/cgroup-defs.h
@@ -557,6 +557,7 @@ struct cftype {
 	struct cgroup_subsys *ss;	/* NULL for cgroup core files */
 	struct list_head node;		/* anchored at ss->cfts */
 	struct kernfs_ops *kf_ops;
+	int numa_node_id;
 
 	int (*open)(struct kernfs_open_file *of);
 	void (*release)(struct kernfs_open_file *of);
diff --git a/include/linux/exchange.h b/include/linux/exchange.h
new file mode 100644
index 000000000000..8785d084d3c0
--- /dev/null
+++ b/include/linux/exchange.h
@@ -0,0 +1,27 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#ifndef _LINUX_EXCHANGE_H
+#define _LINUX_EXCHANGE_H
+
+#include <linux/migrate.h>
+
+struct exchange_page_info {
+	struct page *from_page;
+	struct page *to_page;
+
+	struct anon_vma *from_anon_vma;
+	struct anon_vma *to_anon_vma;
+
+	int from_page_was_mapped;
+	int to_page_was_mapped;
+
+	pgoff_t from_index, to_index;
+
+	struct list_head list;
+};
+
+int exchange_pages(struct list_head *exchange_list,
+			enum migrate_mode mode,
+			int reason);
+int exchange_pages_concur(struct list_head *exchange_list,
+		enum migrate_mode mode, int reason);
+#endif /* _LINUX_EXCHANGE_H */
diff --git a/include/linux/highmem.h b/include/linux/highmem.h
index ea5cdbd8c2c3..2c2b53d5b2fd 100644
--- a/include/linux/highmem.h
+++ b/include/linux/highmem.h
@@ -262,6 +262,8 @@ static inline void copy_user_highpage(struct page *to, struct page *from,
 #endif
 
 #ifndef __HAVE_ARCH_COPY_HIGHPAGE
+int copy_page_multithread(struct page *to, struct page *from, int nr_pages);
+int copy_page_dma(struct page *to, struct page *from, int nr_pages);
 
 static inline void copy_highpage(struct page *to, struct page *from)
 {
diff --git a/include/linux/huge_mm.h b/include/linux/huge_mm.h
index 5aca3d1bdb32..68b3d164b316 100644
--- a/include/linux/huge_mm.h
+++ b/include/linux/huge_mm.h
@@ -266,9 +266,12 @@ void mm_put_huge_zero_page(struct mm_struct *mm);
 
 #define mk_huge_pmd(page, prot) pmd_mkhuge(mk_pmd(page, prot))
 
+extern int sysctl_enable_thp_migration;
+
 static inline bool thp_migration_supported(void)
 {
-	return IS_ENABLED(CONFIG_ARCH_ENABLE_THP_MIGRATION);
+	return IS_ENABLED(CONFIG_ARCH_ENABLE_THP_MIGRATION) &&
+		sysctl_enable_thp_migration;
 }
 
 static inline struct list_head *page_deferred_list(struct page *page)
diff --git a/include/linux/ksm.h b/include/linux/ksm.h
index e48b1e453ff5..935317d1cdd8 100644
--- a/include/linux/ksm.h
+++ b/include/linux/ksm.h
@@ -55,6 +55,7 @@ void rmap_walk_ksm(struct page *page, struct rmap_walk_control *rwc);
 void ksm_migrate_page(struct page *newpage, struct page *oldpage);
 bool reuse_ksm_page(struct page *page,
 			struct vm_area_struct *vma, unsigned long address);
+void ksm_exchange_page(struct page *to_page, struct page *from_page);
 
 #else  /* !CONFIG_KSM */
 
@@ -88,10 +89,16 @@ static inline void rmap_walk_ksm(struct page *page,
 static inline void ksm_migrate_page(struct page *newpage, struct page *oldpage)
 {
 }
+<<<<<<< HEAD
 static inline bool reuse_ksm_page(struct page *page,
 			struct vm_area_struct *vma, unsigned long address)
 {
 	return false;
+=======
+static inline void ksm_exchange_page(struct page *to_page,
+				struct page *from_page)
+{
+>>>>>>> exchange page: Add exchange_pages and exchange_pages_concur functions to
 }
 #endif /* CONFIG_MMU */
 #endif /* !CONFIG_KSM */
diff --git a/include/linux/memcontrol.h b/include/linux/memcontrol.h
index a7a0a1a5c8d5..8d393d6c1ff8 100644
--- a/include/linux/memcontrol.h
+++ b/include/linux/memcontrol.h
@@ -123,6 +123,7 @@ struct mem_cgroup_per_node {
 	atomic_long_t		lruvec_stat[NR_VM_NODE_STAT_ITEMS];
 
 	unsigned long		lru_zone_size[MAX_NR_ZONES][NR_LRU_LISTS];
+	unsigned long		max_nr_base_pages;
 
 	struct mem_cgroup_reclaim_iter	iter;
 
@@ -375,6 +376,9 @@ void mem_cgroup_uncharge_list(struct list_head *page_list);
 
 void mem_cgroup_migrate(struct page *oldpage, struct page *newpage);
 
+unsigned long mem_cgroup_node_nr_lru_pages(struct mem_cgroup *memcg,
+					   int nid, unsigned int lru_mask);
+
 static struct mem_cgroup_per_node *
 mem_cgroup_nodeinfo(struct mem_cgroup *memcg, int nid)
 {
@@ -807,6 +811,54 @@ static inline void memcg_memory_event_mm(struct mm_struct *mm,
 void mem_cgroup_split_huge_fixup(struct page *head);
 #endif
 
+unsigned long mem_cgroup_node_nr_lru_pages(struct mem_cgroup *memcg,
+					   int nid, unsigned int lru_mask);
+
+static inline unsigned long lruvec_size_memcg_node(enum lru_list lru,
+	struct mem_cgroup *memcg, int nid)
+{
+	if (nid == MAX_NUMNODES)
+		return 0;
+
+	VM_BUG_ON(lru < 0 || lru >= NR_LRU_LISTS);
+	return mem_cgroup_node_nr_lru_pages(memcg, nid, BIT(lru));
+}
+
+static inline unsigned long active_inactive_size_memcg_node(struct mem_cgroup *memcg, int nid, bool active)
+{
+	unsigned long val = 0;
+	enum lru_list lru;
+
+	for_each_evictable_lru(lru) {
+		if ((active  && is_active_lru(lru)) ||
+			(!active && !is_active_lru(lru)))
+			val += mem_cgroup_node_nr_lru_pages(memcg, nid, BIT(lru));
+	}
+
+	return val;
+}
+
+static inline unsigned long memcg_size_node(struct mem_cgroup *memcg, int nid)
+{
+	unsigned long val = 0;
+	int i;
+
+	if (nid == MAX_NUMNODES)
+		return val;
+
+	for (i = 0; i < NR_LRU_LISTS; i++)
+		val += mem_cgroup_node_nr_lru_pages(memcg, nid, BIT(i));
+
+	return val;
+}
+
+static inline unsigned long memcg_max_size_node(struct mem_cgroup *memcg, int nid)
+{
+	if (nid == MAX_NUMNODES)
+		return 0;
+	return memcg->nodeinfo[nid]->max_nr_base_pages;
+}
+
 #else /* CONFIG_MEMCG */
 
 #define MEM_CGROUP_ID_SHIFT	0
@@ -1468,6 +1520,27 @@ static inline void memcg_put_cache_ids(void)
 {
 }
 
-#endif /* CONFIG_MEMCG_KMEM */
+static inline unsigned long lruvec_size_memcg_node(enum lru_list lru,
+	struct mem_cgroup *memcg, int nid)
+{
+	return 0;
+}
+
+static inline unsigned long active_inactive_size_memcg_node(struct mem_cgroup *memcg, int nid, bool active)
+{
+	return 0;
+}
+
+static inline unsigned long memcg_size_node(struct mem_cgroup *memcg, int nid)
+{
+	return 0;
+}
+static inline unsigned long memcg_max_size_node(struct mem_cgroup *memcg, int nid)
+{
+	return 0;
+}
+
+#endif /* CONFIG_MEMCG */
+
 
 #endif /* _LINUX_MEMCONTROL_H */
diff --git a/include/linux/migrate.h b/include/linux/migrate.h
index 72120061b7d4..2594c4f1f1cf 100644
--- a/include/linux/migrate.h
+++ b/include/linux/migrate.h
@@ -67,13 +67,16 @@ extern int migrate_page(struct address_space *mapping,
 			enum migrate_mode mode);
 extern int migrate_pages(struct list_head *l, new_page_t new, free_page_t free,
 		unsigned long private, enum migrate_mode mode, int reason);
+extern int migrate_pages_concur(struct list_head *l, new_page_t new, free_page_t free,
+		unsigned long private, enum migrate_mode mode, int reason);
 extern int isolate_movable_page(struct page *page, isolate_mode_t mode);
 extern void putback_movable_page(struct page *page);
 
 extern int migrate_prep(void);
 extern int migrate_prep_local(void);
 extern void migrate_page_states(struct page *newpage, struct page *page);
-extern void migrate_page_copy(struct page *newpage, struct page *page);
+extern void migrate_page_copy(struct page *newpage, struct page *page,
+				  enum migrate_mode mode);
 extern int migrate_huge_page_move_mapping(struct address_space *mapping,
 				  struct page *newpage, struct page *page);
 extern int migrate_page_move_mapping(struct address_space *mapping,
@@ -85,6 +88,10 @@ static inline int migrate_pages(struct list_head *l, new_page_t new,
 		free_page_t free, unsigned long private, enum migrate_mode mode,
 		int reason)
 	{ return -ENOSYS; }
+static inline int migrate_pages_concur(struct list_head *l, new_page_t new,
+		free_page_t free, unsigned long private, enum migrate_mode mode,
+		int reason)
+	{ return -ENOSYS; }
 static inline int isolate_movable_page(struct page *page, isolate_mode_t mode)
 	{ return -EBUSY; }
 
@@ -96,7 +103,8 @@ static inline void migrate_page_states(struct page *newpage, struct page *page)
 }
 
 static inline void migrate_page_copy(struct page *newpage,
-				     struct page *page) {}
+				     struct page *page,
+				     enum migrate_mode mode) {}
 
 static inline int migrate_huge_page_move_mapping(struct address_space *mapping,
 				  struct page *newpage, struct page *page)
diff --git a/include/linux/migrate_mode.h b/include/linux/migrate_mode.h
index 883c99249033..3a07cf5842f7 100644
--- a/include/linux/migrate_mode.h
+++ b/include/linux/migrate_mode.h
@@ -11,12 +11,20 @@
  *	with the CPU. Instead, page copy happens outside the migratepage()
  *	callback and is likely using a DMA engine. See migrate_vma() and HMM
  *	(mm/hmm.c) for users of this mode.
+ * MIGRATE_SINGLETHREAD uses a single thread to move pages, it is the default
+ *	behavior
  */
 enum migrate_mode {
 	MIGRATE_ASYNC,
 	MIGRATE_SYNC_LIGHT,
 	MIGRATE_SYNC,
-	MIGRATE_SYNC_NO_COPY,
+
+	MIGRATE_MODE_MASK = 7,
+	MIGRATE_SYNC_NO_COPY = 1<<3,
+	MIGRATE_SINGLETHREAD	= 0,
+	MIGRATE_MT				= 1<<4,
+	MIGRATE_DMA				= 1<<5,
+	MIGRATE_CONCUR			= 1<<6,
 };
 
 #endif		/* MIGRATE_MODE_H_INCLUDED */
diff --git a/include/linux/mm_inline.h b/include/linux/mm_inline.h
index 6f2fef7b0784..f66fa2b5e715 100644
--- a/include/linux/mm_inline.h
+++ b/include/linux/mm_inline.h
@@ -44,6 +44,27 @@ static __always_inline void update_lru_size(struct lruvec *lruvec,
 #endif
 }
 
+/*
+ * Update LRU sizes after isolating pages. The LRU size updates must
+ * be complete before mem_cgroup_update_lru_size due to a santity check.
+ */
+static __always_inline void update_lru_sizes(struct lruvec *lruvec,
+			enum lru_list lru, unsigned long *nr_zone_taken)
+{
+	int zid;
+
+	for (zid = 0; zid < MAX_NR_ZONES; zid++) {
+		if (!nr_zone_taken[zid])
+			continue;
+
+		__update_lru_size(lruvec, lru, zid, -nr_zone_taken[zid]);
+#ifdef CONFIG_MEMCG
+		mem_cgroup_update_lru_size(lruvec, lru, zid, -nr_zone_taken[zid]);
+#endif
+	}
+
+}
+
 static __always_inline void add_page_to_lru_list(struct page *page,
 				struct lruvec *lruvec, enum lru_list lru)
 {
diff --git a/include/linux/sched.h b/include/linux/sched.h
index 04278493bf15..7cc3d1c06361 100644
--- a/include/linux/sched.h
+++ b/include/linux/sched.h
@@ -61,6 +61,47 @@ struct signal_struct;
 struct task_delay_info;
 struct task_group;
 
+#ifdef CONFIG_PAGE_MIGRATION_PROFILE
+struct move_pages_breakdown {
+	unsigned long long last_timestamp;
+
+	unsigned long long syscall_timestamp;
+	unsigned long long check_rights_cycles;
+	unsigned long long migrate_prep_cycles;
+	unsigned long long form_page_node_info_cycles;
+	unsigned long long form_physical_page_list_cycles;
+	unsigned long long enter_unmap_and_move_cycles;
+	unsigned long long split_thp_page_cycles;
+	unsigned long long get_new_page_cycles;
+	unsigned long long lock_page_cycles;
+	unsigned long long unmap_page_cycles;
+	unsigned long long change_page_mapping_cycles;
+	unsigned long long copy_page_cycles;
+	unsigned long long remove_migration_ptes_cycles;
+	unsigned long long putback_old_page_cycles;
+	unsigned long long putback_new_page_cycles;
+	unsigned long long migrate_pages_cleanup_cycles;
+	unsigned long long store_page_status_cycles;
+	unsigned long long return_to_syscall_cycles;
+};
+#endif
+
+struct page_migration_counters {
+	unsigned long nr_migrations;
+	unsigned long nr_base_pages;
+	unsigned long nr_huge_pages;
+};
+
+struct page_migration_stats {
+	unsigned long base_page_under_migration_jiffies;
+	unsigned long huge_page_under_migration_jiffies;
+	unsigned long nr_exchanges;
+	unsigned long nr_exchange_base_pages;
+	unsigned long nr_exchange_huge_pages;
+	struct page_migration_counters f2s; /* fast to slow */
+	struct page_migration_counters s2f; /* slow to fast */
+};
+
 /*
  * Task state bitmask. NOTE! These bits are also
  * encoded in fs/proc/array.c: get_task_state().
@@ -870,6 +911,11 @@ struct task_struct {
 
 	/* Empty if CONFIG_POSIX_CPUTIMERS=n */
 	struct posix_cputimers		posix_cputimers;
+#ifdef CONFIG_PAGE_MIGRATION_PROFILE
+	struct move_pages_breakdown move_pages_breakdown;
+#endif
+
+	struct page_migration_stats page_migration_stats;
 
 	/* Process credentials: */
 
diff --git a/include/linux/sched/coredump.h b/include/linux/sched/coredump.h
index ecdc6542070f..113f4ff4d123 100644
--- a/include/linux/sched/coredump.h
+++ b/include/linux/sched/coredump.h
@@ -73,6 +73,7 @@ static inline int get_dumpable(struct mm_struct *mm)
 #define MMF_OOM_VICTIM		25	/* mm is the oom victim */
 #define MMF_OOM_REAP_QUEUED	26	/* mm was queued for oom_reaper */
 #define MMF_DISABLE_THP_MASK	(1 << MMF_DISABLE_THP)
+#define MMF_MM_MANAGE		26
 
 #define MMF_INIT_MASK		(MMF_DUMPABLE_MASK | MMF_DUMP_FILTER_MASK |\
 				 MMF_DISABLE_THP_MASK)
diff --git a/include/linux/sched/signal.h b/include/linux/sched/signal.h
index 88050259c466..ecfa03c6a880 100644
--- a/include/linux/sched/signal.h
+++ b/include/linux/sched/signal.h
@@ -181,6 +181,7 @@ struct signal_struct {
 	unsigned long maxrss, cmaxrss;
 	struct task_io_accounting ioac;
 
+	struct page_migration_stats page_migration_stats;
 	/*
 	 * Cumulative ns of schedule CPU time fo dead threads in the
 	 * group, not including a zombie group leader, (This only differs
diff --git a/include/linux/sched/sysctl.h b/include/linux/sched/sysctl.h
index d4f6215ee03f..df8999543973 100644
--- a/include/linux/sched/sysctl.h
+++ b/include/linux/sched/sysctl.h
@@ -101,4 +101,7 @@ extern int sched_energy_aware_handler(struct ctl_table *table, int write,
 				 loff_t *ppos);
 #endif
 
+extern int sysctl_dma_page_migration(struct ctl_table *table, int write,
+				 void __user *buffer, size_t *lenp,
+				 loff_t *ppos);
 #endif /* _LINUX_SCHED_SYSCTL_H */
diff --git a/include/linux/syscalls.h b/include/linux/syscalls.h
index 1815065d52f3..aab6dcc9386b 100644
--- a/include/linux/syscalls.h
+++ b/include/linux/syscalls.h
@@ -1422,4 +1422,14 @@ long compat_ksys_semtimedop(int semid, struct sembuf __user *tsems,
 			    unsigned int nsops,
 			    const struct old_timespec32 __user *timeout);
 
+asmlinkage long sys_exchange_pages(pid_t pid, unsigned long nr_pages,
+				const void __user * __user *from_pages,
+				const void __user * __user *to_pages,
+				int __user *status,
+				int flags);
+asmlinkage long sys_mm_manage(pid_t pid, unsigned long nr_pages,
+				unsigned long maxnode,
+				const unsigned long __user *old_nodes,
+				const unsigned long __user *new_nodes,
+				int flags);
 #endif
diff --git a/include/uapi/linux/mempolicy.h b/include/uapi/linux/mempolicy.h
index 3354774af61e..dac474a25144 100644
--- a/include/uapi/linux/mempolicy.h
+++ b/include/uapi/linux/mempolicy.h
@@ -28,12 +28,13 @@ enum {
 /* Flags for set_mempolicy */
 #define MPOL_F_STATIC_NODES	(1 << 15)
 #define MPOL_F_RELATIVE_NODES	(1 << 14)
+#define MPOL_F_MEMCG		(1 << 13)
 
 /*
  * MPOL_MODE_FLAGS is the union of all possible optional mode flags passed to
  * either set_mempolicy() or mbind().
  */
-#define MPOL_MODE_FLAGS	(MPOL_F_STATIC_NODES | MPOL_F_RELATIVE_NODES)
+#define MPOL_MODE_FLAGS	(MPOL_F_STATIC_NODES | MPOL_F_RELATIVE_NODES | MPOL_F_MEMCG)
 
 /* Flags for get_mempolicy */
 #define MPOL_F_NODE	(1<<0)	/* return next IL mode instead of node mask */
@@ -48,6 +49,12 @@ enum {
 #define MPOL_MF_LAZY	 (1<<3)	/* Modifies '_MOVE:  lazy migrate on fault */
 #define MPOL_MF_INTERNAL (1<<4)	/* Internal flags start here */
 
+#define MPOL_MF_MOVE_DMA (1<<5)	/* Use DMA page copy routine */
+#define MPOL_MF_MOVE_MT  (1<<6)	/* Use multi-threaded page copy routine */
+#define MPOL_MF_MOVE_CONCUR  (1<<7)	/* Move pages in a batch */
+#define MPOL_MF_EXCHANGE	(1<<8)	/* Exchange pages */
+#define MPOL_MF_SHRINK_LISTS	(1<<9)	/* Exchange pages */
+
 #define MPOL_MF_VALID	(MPOL_MF_STRICT   | 	\
 			 MPOL_MF_MOVE     | 	\
 			 MPOL_MF_MOVE_ALL)
diff --git a/kernel/exit.c b/kernel/exit.c
index 0b81b26a872a..e196e4b2900e 100644
--- a/kernel/exit.c
+++ b/kernel/exit.c
@@ -154,6 +154,28 @@ static void __exit_signal(struct task_struct *tsk)
 	task_io_accounting_add(&sig->ioac, &tsk->ioac);
 	sig->sum_sched_runtime += tsk->se.sum_exec_runtime;
 	sig->nr_threads--;
+
+#define ADD_PAGE_MIGRATION_COUNTERS(dst, src)\
+	do { \
+		dst.nr_migrations += src.nr_migrations;\
+		dst.nr_base_pages += src.nr_base_pages;\
+		dst.nr_huge_pages += src.nr_huge_pages;\
+	} while (0);
+
+#define ADD_PAGE_MIGRATION_STATS(dst, src)\
+		do {\
+			dst.base_page_under_migration_jiffies += src.base_page_under_migration_jiffies;\
+			dst.huge_page_under_migration_jiffies += src.huge_page_under_migration_jiffies;\
+			dst.nr_exchanges += src.nr_exchanges;\
+			dst.nr_exchange_base_pages += src.nr_exchange_base_pages;\
+			dst.nr_exchange_huge_pages += src.nr_exchange_huge_pages;\
+			ADD_PAGE_MIGRATION_COUNTERS(dst.f2s, src.f2s);\
+			ADD_PAGE_MIGRATION_COUNTERS(dst.s2f, src.s2f);\
+		} while (0);
+
+		ADD_PAGE_MIGRATION_STATS(sig->page_migration_stats,
+				tsk->page_migration_stats);
+
 	__unhash_process(tsk, group_dead);
 	write_sequnlock(&sig->stats_lock);
 
@@ -1053,6 +1075,15 @@ static int wait_task_zombie(struct wait_opts *wo, struct task_struct *p)
 		psig->coublock +=
 			task_io_get_oublock(p) +
 			sig->oublock + sig->coublock;
+
+		ADD_PAGE_MIGRATION_STATS(psig->page_migration_stats,
+				p->page_migration_stats);
+		ADD_PAGE_MIGRATION_STATS(psig->page_migration_stats,
+				sig->page_migration_stats);
+
+#undef ADD_PAGE_MIGRATION_STATS
+#undef ADD_PAGE_MIGRATION_COUNTERS
+
 		maxrss = max(sig->maxrss, sig->cmaxrss);
 		if (psig->cmaxrss < maxrss)
 			psig->cmaxrss = maxrss;
diff --git a/kernel/fork.c b/kernel/fork.c
index 86425305cd4a..c559f295170f 100644
--- a/kernel/fork.c
+++ b/kernel/fork.c
@@ -1593,6 +1593,8 @@ static int copy_signal(unsigned long clone_flags, struct task_struct *tsk)
 	sig->oom_score_adj = current->signal->oom_score_adj;
 	sig->oom_score_adj_min = current->signal->oom_score_adj_min;
 
+	sig->page_migration_stats = (struct page_migration_stats){0};
+
 	mutex_init(&sig->cred_guard_mutex);
 
 	return 0;
@@ -1974,6 +1976,11 @@ static __latent_entropy struct task_struct *copy_process(
 
 	init_sigpending(&p->pending);
 
+#ifdef CONFIG_PAGE_MIGRATION_PROFILE
+	p->move_pages_breakdown = (struct move_pages_breakdown){0};
+#endif
+	p->page_migration_stats = (struct page_migration_stats){0};
+
 	p->utime = p->stime = p->gtime = 0;
 #ifdef CONFIG_ARCH_HAS_SCALED_CPUTIME
 	p->utimescaled = p->stimescaled = 0;
